;;
;; sha1 - Scheme wrapper for Steve Reid's Public Domain sha1 implementation
;;
;; All code in this egg is in the Public Domain

#>#include "sha1-base.c"<#

(module sha1-api

(;export
  name version
  context-size digest-length block-length
  init update final raw-update)

(import scheme
  (chicken base)
  (chicken foreign))

;;

(define name 'sha1)
(define version '1.0.0)

;;

(define-foreign-variable *digest-length* unsigned-int "SHA1_DIGEST_LENGTH")
(define-foreign-variable *block-length* unsigned-int "SHA1_BLOCK_LENGTH")
(define-foreign-variable *context-size* unsigned-int "sizeof(SHA1_CTX)")

(define context-size *context-size*)
(define digest-length *digest-length*)
(define block-length *block-length*)

;;

(define init (foreign-lambda void SHA1Init c-pointer))
(define update (foreign-lambda void SHA1Update c-pointer scheme-pointer unsigned-int))
(define final (foreign-lambda void SHA1Final c-pointer scheme-pointer))
(define raw-update (foreign-lambda void SHA1Update c-pointer c-pointer unsigned-int))

) ;sha1-api
